git-stash.sh 9.94 KB
Newer Older
しらいしななこ's avatar
しらいしななこ committed
1 2 3
#!/bin/sh
# Copyright (c) 2007, Nanako Shiraishi

4 5
dashless=$(basename "$0" | sed -e 's/-/ /')
USAGE="list [<options>]
Stephen Boyd's avatar
Stephen Boyd committed
6 7 8
   or: $dashless show [<stash>]
   or: $dashless drop [-q|--quiet] [<stash>]
   or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9
   or: $dashless branch <branchname> [<stash>]
10
   or: $dashless [save [--patch] [-k|--[no-]keep-index] [-q|--quiet] [<message>]]
11
   or: $dashless clear"
しらいしななこ's avatar
しらいしななこ committed
12

13
SUBDIRECTORY_OK=Yes
14
OPTIONS_SPEC=
15
START_DIR=`pwd`
しらいしななこ's avatar
しらいしななこ committed
16
. git-sh-setup
17
. git-sh-i18n
しらいしななこ's avatar
しらいしななこ committed
18
require_work_tree
19
cd_to_toplevel
しらいしななこ's avatar
しらいしななこ committed
20 21

TMP="$GIT_DIR/.git-stash.$$"
22 23
TMPindex=${GIT_INDEX_FILE-"$GIT_DIR/index"}.stash.$$
trap 'rm -f "$TMP-"* "$TMPindex"' 0
しらいしななこ's avatar
しらいしななこ committed
24 25 26

ref_stash=refs/stash

27 28 29 30 31 32 33 34
if git config --get-colorbool color.interactive; then
       help_color="$(git config --get-color color.interactive.help 'red bold')"
       reset_color="$(git config --get-color '' reset)"
else
       help_color=
       reset_color=
fi

しらいしななこ's avatar
しらいしななこ committed
35
no_changes () {
36 37
	git diff-index --quiet --cached HEAD --ignore-submodules -- &&
	git diff-files --quiet --ignore-submodules
しらいしななこ's avatar
しらいしななこ committed
38 39 40
}

clear_stash () {
41 42 43 44
	if test $# != 0
	then
		die "git stash clear with parameters is unimplemented"
	fi
45
	if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
46
	then
Emil Medve's avatar
Emil Medve committed
47
		git update-ref -d $ref_stash $current
48
	fi
しらいしななこ's avatar
しらいしななこ committed
49 50
}

51
create_stash () {
52 53
	stash_msg="$1"

54
	git update-index -q --refresh
しらいしななこ's avatar
しらいしななこ committed
55 56 57 58
	if no_changes
	then
		exit 0
	fi
59

しらいしななこ's avatar
しらいしななこ committed
60
	# state of the base commit
61
	if b_commit=$(git rev-parse --verify HEAD)
しらいしななこ's avatar
しらいしななこ committed
62
	then
63
		head=$(git rev-list --oneline -n 1 HEAD --)
しらいしななこ's avatar
しらいしななこ committed
64 65 66 67
	else
		die "You do not have the initial commit yet"
	fi

68
	if branch=$(git symbolic-ref -q HEAD)
しらいしななこ's avatar
しらいしななこ committed
69 70 71 72 73 74 75 76
	then
		branch=${branch#refs/heads/}
	else
		branch='(no branch)'
	fi
	msg=$(printf '%s: %s' "$branch" "$head")

	# state of the index
77
	i_tree=$(git write-tree) &&
78
	i_commit=$(printf 'index on %s\n' "$msg" |
79
		git commit-tree $i_tree -p $b_commit) ||
しらいしななこ's avatar
しらいしななこ committed
80 81
		die "Cannot save the current index state"

82 83 84 85 86
	if test -z "$patch_mode"
	then

		# state of the working tree
		w_tree=$( (
87 88
			git read-tree --index-output="$TMPindex" -m $i_tree &&
			GIT_INDEX_FILE="$TMPindex" &&
89
			export GIT_INDEX_FILE &&
90
			git diff --name-only -z HEAD | git update-index -z --add --remove --stdin &&
91
			git write-tree &&
92
			rm -f "$TMPindex"
93 94 95 96 97
		) ) ||
			die "Cannot save the current worktree state"

	else

98
		rm -f "$TMP-index" &&
99 100 101 102 103 104 105 106
		GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&

		# find out what the user wants
		GIT_INDEX_FILE="$TMP-index" \
			git add--interactive --patch=stash -- &&

		# state of the working tree
		w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
しらいしななこ's avatar
しらいしななこ committed
107 108
		die "Cannot save the current worktree state"

109 110 111 112 113 114 115 116 117
		git diff-tree -p HEAD $w_tree > "$TMP-patch" &&
		test -s "$TMP-patch" ||
		die "No changes selected"

		rm -f "$TMP-index" ||
		die "Cannot remove temporary index (can't happen)"

	fi

しらいしななこ's avatar
しらいしななこ committed
118
	# create the stash
119 120 121 122 123 124 125
	if test -z "$stash_msg"
	then
		stash_msg=$(printf 'WIP on %s' "$msg")
	else
		stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
	fi
	w_commit=$(printf '%s\n' "$stash_msg" |
126
		git commit-tree $w_tree -p $b_commit -p $i_commit) ||
しらいしななこ's avatar
しらいしななこ committed
127
		die "Cannot record working tree state"
128
}
しらいしななこ's avatar
しらいしななこ committed
129

130
save_stash () {
131
	keep_index=
132
	patch_mode=
Stephen Boyd's avatar
Stephen Boyd committed
133 134 135
	while test $# != 0
	do
		case "$1" in
136
		-k|--keep-index)
Stephen Boyd's avatar
Stephen Boyd committed
137 138
			keep_index=t
			;;
139
		--no-keep-index)
140
			keep_index=n
141 142 143
			;;
		-p|--patch)
			patch_mode=t
144 145
			# only default to keep if we don't already have an override
			test -z "$keep_index" && keep_index=t
Stephen Boyd's avatar
Stephen Boyd committed
146 147 148 149
			;;
		-q|--quiet)
			GIT_QUIET=t
			;;
150 151 152 153 154 155
		--)
			shift
			break
			;;
		-*)
			echo "error: unknown option for 'stash save': $1"
156
			echo "       To provide a message, use git stash save -- '$1'"
157 158
			usage
			;;
Stephen Boyd's avatar
Stephen Boyd committed
159 160 161 162
		*)
			break
			;;
		esac
163
		shift
Stephen Boyd's avatar
Stephen Boyd committed
164
	done
165

166
	stash_msg="$*"
167

168
	git update-index -q --refresh
169 170
	if no_changes
	then
Stephen Boyd's avatar
Stephen Boyd committed
171
		say 'No local changes to save'
172 173 174 175 176 177
		exit 0
	fi
	test -f "$GIT_DIR/logs/$ref_stash" ||
		clear_stash || die "Cannot initialize stash"

	create_stash "$stash_msg"
Emil Medve's avatar
Emil Medve committed
178 179 180

	# Make sure the reflog for stash is kept.
	: >>"$GIT_DIR/logs/$ref_stash"
しらいしななこ's avatar
しらいしななこ committed
181

182
	git update-ref -m "$stash_msg" $ref_stash $w_commit ||
しらいしななこ's avatar
しらいしななこ committed
183
		die "Cannot save the current status"
Stephen Boyd's avatar
Stephen Boyd committed
184
	say Saved working directory and index state "$stash_msg"
185

186
	if test -z "$patch_mode"
187
	then
188 189
		git reset --hard ${GIT_QUIET:+-q}

190
		if test "$keep_index" = "t" && test -n $i_tree
191 192 193 194 195 196 197
		then
			git read-tree --reset -u $i_tree
		fi
	else
		git apply -R < "$TMP-patch" ||
		die "Cannot remove worktree changes"

198
		if test "$keep_index" != "t"
199 200 201
		then
			git reset
		fi
202
	fi
しらいしななこ's avatar
しらいしななこ committed
203 204
}

205
have_stash () {
206
	git rev-parse --verify $ref_stash >/dev/null 2>&1
207 208
}

しらいしななこ's avatar
しらいしななこ committed
209
list_stash () {
210
	have_stash || return 0
211
	git log --format="%gd: %gs" -g "$@" $ref_stash --
しらいしななこ's avatar
しらいしななこ committed
212 213 214
}

show_stash () {
215
	assert_stash_like "$@"
216

217
	git diff ${FLAGS:---stat} $b_commit $w_commit
しらいしななこ's avatar
しらいしななこ committed
218 219
}

220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268
#
# Parses the remaining options looking for flags and
# at most one revision defaulting to ${ref_stash}@{0}
# if none found.
#
# Derives related tree and commit objects from the
# revision, if one is found.
#
# stash records the work tree, and is a merge between the
# base commit (first parent) and the index tree (second parent).
#
#   REV is set to the symbolic version of the specified stash-like commit
#   IS_STASH_LIKE is non-blank if ${REV} looks like a stash
#   IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
#   s is set to the SHA1 of the stash commit
#   w_commit is set to the commit containing the working tree
#   b_commit is set to the base commit
#   i_commit is set to the commit containing the index tree
#   w_tree is set to the working tree
#   b_tree is set to the base tree
#   i_tree is set to the index tree
#
#   GIT_QUIET is set to t if -q is specified
#   INDEX_OPTION is set to --index if --index is specified.
#   FLAGS is set to the remaining flags
#
# dies if:
#   * too many revisions specified
#   * no revision is specified and there is no stash stack
#   * a revision is specified which cannot be resolve to a SHA1
#   * a non-existent stash reference is specified
#

parse_flags_and_rev()
{
	test "$PARSE_CACHE" = "$*" && return 0 # optimisation
	PARSE_CACHE="$*"

	IS_STASH_LIKE=
	IS_STASH_REF=
	INDEX_OPTION=
	s=
	w_commit=
	b_commit=
	i_commit=
	w_tree=
	b_tree=
	i_tree=

269
	REV=$(git rev-parse --no-flags --symbolic "$@") || exit 1
270 271

	FLAGS=
Jon Seymour's avatar
Jon Seymour committed
272
	for opt
273
	do
Jon Seymour's avatar
Jon Seymour committed
274 275 276 277
		case "$opt" in
			-q|--quiet)
				GIT_QUIET=-t
			;;
278 279 280
			--index)
				INDEX_OPTION=--index
			;;
Jon Seymour's avatar
Jon Seymour committed
281 282
			-*)
				FLAGS="${FLAGS}${FLAGS:+ }$opt"
283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 334
			;;
		esac
	done

	set -- $REV

	case $# in
		0)
			have_stash || die "No stash found."
			set -- ${ref_stash}@{0}
		;;
		1)
			:
		;;
		*)
			die "Too many revisions specified: $REV"
		;;
	esac

	REV=$(git rev-parse --quiet --symbolic --verify $1 2>/dev/null) || die "$1 is not valid reference"

	i_commit=$(git rev-parse --quiet --verify $REV^2 2>/dev/null) &&
	set -- $(git rev-parse $REV $REV^1 $REV: $REV^1: $REV^2: 2>/dev/null) &&
	s=$1 &&
	w_commit=$1 &&
	b_commit=$2 &&
	w_tree=$3 &&
	b_tree=$4 &&
	i_tree=$5 &&
	IS_STASH_LIKE=t &&
	test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
	IS_STASH_REF=t
}

is_stash_like()
{
	parse_flags_and_rev "$@"
	test -n "$IS_STASH_LIKE"
}

assert_stash_like() {
	is_stash_like "$@" || die "'$*' is not a stash-like commit"
}

is_stash_ref() {
	is_stash_like "$@" && test -n "$IS_STASH_REF"
}

assert_stash_ref() {
	is_stash_ref "$@" || die "'$*' is not a stash reference"
}

しらいしななこ's avatar
しらいしななこ committed
335
apply_stash () {
Stephen Boyd's avatar
Stephen Boyd committed
336

337
	assert_stash_like "$@"
しらいしななこ's avatar
しらいしななこ committed
338

339
	git update-index -q --refresh || die 'unable to refresh index'
340 341 342 343 344

	# current index state
	c_tree=$(git write-tree) ||
		die 'Cannot apply a stash in the middle of a merge'

Junio C Hamano's avatar
Junio C Hamano committed
345
	unstashed_index_tree=
346
	if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
347
			test "$c_tree" != "$i_tree"
Junio C Hamano's avatar
Junio C Hamano committed
348
	then
349
		git diff-tree --binary $s^2^..$s^2 | git apply --cached
350 351
		test $? -ne 0 &&
			die 'Conflicts in index. Try without --index.'
352
		unstashed_index_tree=$(git write-tree) ||
353 354
			die 'Could not save index tree'
		git reset
Junio C Hamano's avatar
Junio C Hamano committed
355
	fi
356

しらいしななこ's avatar
しらいしななこ committed
357 358 359 360 361 362 363
	eval "
		GITHEAD_$w_tree='Stashed changes' &&
		GITHEAD_$c_tree='Updated upstream' &&
		GITHEAD_$b_tree='Version stash was based on' &&
		export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
	"

Stephen Boyd's avatar
Stephen Boyd committed
364 365
	if test -n "$GIT_QUIET"
	then
366
		GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
Stephen Boyd's avatar
Stephen Boyd committed
367
	fi
368
	if git merge-recursive $b_tree -- $c_tree $w_tree
しらいしななこ's avatar
しらいしななこ committed
369 370
	then
		# No conflict
Junio C Hamano's avatar
Junio C Hamano committed
371 372 373
		if test -n "$unstashed_index_tree"
		then
			git read-tree "$unstashed_index_tree"
374 375
		else
			a="$TMP-added" &&
376
			git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
377 378 379 380
			git read-tree --reset $c_tree &&
			git update-index --add --stdin <"$a" ||
				die "Cannot unstage modified files"
			rm -f "$a"
Junio C Hamano's avatar
Junio C Hamano committed
381
		fi
Stephen Boyd's avatar
Stephen Boyd committed
382 383 384 385 386
		squelch=
		if test -n "$GIT_QUIET"
		then
			squelch='>/dev/null 2>&1'
		fi
387
		(cd "$START_DIR" && eval "git status $squelch") || :
しらいしななこ's avatar
しらいしななこ committed
388 389
	else
		# Merge conflict; keep the exit status from merge-recursive
390
		status=$?
391
		if test -n "$INDEX_OPTION"
Junio C Hamano's avatar
Junio C Hamano committed
392 393 394
		then
			echo >&2 'Index was not unstashed.'
		fi
395
		exit $status
しらいしななこ's avatar
しらいしななこ committed
396 397 398
	fi
}

399 400 401 402 403 404 405
pop_stash() {
	assert_stash_ref "$@"

	apply_stash "$@" &&
	drop_stash "$@"
}

406
drop_stash () {
407
	assert_stash_ref "$@"
408

409 410
	git reflog delete --updateref --rewrite "${REV}" &&
		say "Dropped ${REV} ($s)" || die "${REV}: Could not drop stash entry"
411 412

	# clear_stash if we just dropped the last stash entry
413
	git rev-parse --verify "$ref_stash@{0}" > /dev/null 2>&1 || clear_stash
414 415
}

416 417 418
apply_to_branch () {
	test -n "$1" || die 'No branch name specified'
	branch=$1
419
	shift 1
420

421 422 423 424
	set -- --index "$@"
	assert_stash_like "$@"

	git checkout -b $branch $REV^ &&
425 426 427
	apply_stash "$@" && {
		test -z "$IS_STASH_REF" || drop_stash "$@"
	}
428 429
}

430
PARSE_CACHE='--not-parsed'
431 432 433 434 435 436 437 438 439 440 441 442
# The default command is "save" if nothing but options are given
seen_non_option=
for opt
do
	case "$opt" in
	-*) ;;
	*) seen_non_option=t; break ;;
	esac
done

test -n "$seen_non_option" || set "save" "$@"

しらいしななこ's avatar
しらいしななこ committed
443 444
# Main command set
case "$1" in
445 446
list)
	shift
しらいしななこ's avatar
しらいしななこ committed
447 448 449 450 451 452
	list_stash "$@"
	;;
show)
	shift
	show_stash "$@"
	;;
453 454
save)
	shift
455
	save_stash "$@"
456
	;;
しらいしななこ's avatar
しらいしななこ committed
457 458 459 460 461
apply)
	shift
	apply_stash "$@"
	;;
clear)
462 463
	shift
	clear_stash "$@"
しらいしななこ's avatar
しらいしななこ committed
464
	;;
465 466 467 468 469 470 471
create)
	if test $# -gt 0 && test "$1" = create
	then
		shift
	fi
	create_stash "$*" && echo "$w_commit"
	;;
472 473 474 475
drop)
	shift
	drop_stash "$@"
	;;
476 477
pop)
	shift
478
	pop_stash "$@"
479
	;;
480 481 482 483
branch)
	shift
	apply_to_branch "$@"
	;;
しらいしななこ's avatar
しらいしななこ committed
484
*)
485 486
	case $# in
	0)
487
		save_stash &&
Stephen Boyd's avatar
Stephen Boyd committed
488
		say '(To restore them type "git stash apply")'
489 490
		;;
	*)
491
		usage
492
	esac
493
	;;
しらいしななこ's avatar
しらいしななこ committed
494
esac